function wundergroundMetric(pwsData, parent){
	parent.find('.temp').html((Math.round((pwsData.temp_f - 32) * (5/9) * 100)/100) + " C");
	parent.find('.pressure').html((Math.round(pwsData.pressure_in * 33.8637526 * 100)/100) + " mb");
	parent.find('.dewpoint').html((Math.round((pwsData.dewpoint_f - 32) * (5/9) * 100)/100) + " C");
	parent.find('.wind').html(pwsData.wind_dir + " @ " + (Math.round(pwsData.wind_mph * 1.609344 * 100)/100) + " km/h");
	parent.find('.gusts').html((Math.round(pwsData.wind_gust_mph * 1.609344 * 100)/100) + " km/h");
	parent.find('.precip').html((Math.round(pwsData.precip_in * 25.4 * 100)/100) + " mm today");
}

function wundergroundEnglish(pwsData, parent){
	parent.find('.temp').html(pwsData.temp_f + " F");
	parent.find('.pressure').html(pwsData.pressure_in + "\"");
	parent.find('.dewpoint').html(pwsData.dewpoint_f + " F");
	parent.find('.wind').html(pwsData.wind_dir + " @ " + pwsData.wind_mph + " mph");
	parent.find('.gusts').html(pwsData.wind_gust_mph + " mph");
	parent.find('.precip').html(pwsData.precip_in + " \" today");
}

Drupal.behaviors.wunderground = function(context){


	// condense the settings object
	var pws = Drupal.settings.wundergroundpws;

	// unit conversion click
	$('.wunderground-units a').click(function(){

		// find the right identifier to use for the pws array
		var parent = $(this).parents('.block').eq(0);
		var parentId = parent.attr('id');
		idSplit = parentId.split('-');

		if (parentId == 'block-wunderground-0'){
			pwsData = pws['default'];
		} else if (idSplit[1] == 'multiblock') {
			id = idSplit[2];
			pwsData = pws['multi_' + id]
		}

		// which operation?
		if ($(this).hasClass('english')){
			wundergroundEnglish(pwsData, parent);
		} else if ($(this).hasClass('metric')){
			wundergroundMetric(pwsData, parent);
		}
	});

	// initial unit conversion
	if (pws['units'] == "Metric") {
		$('.wunderground-units a.metric').click();
	} else {
		$('.wunderground-units a.english').click();
	}

	/*** AJAX Lookup block ***/

	// ajax location lookup submit
	$('#wunderground-lookup-block-form').submit(function(){
		document.getElementById('edit-submit').disabled = true;
		textfield = $(this).find('#edit-query');
		textfield.after('<div id="wunderground-ajax-throbber"></div>');

		// ie likes this better than $.post in this case
		var ajaxRequest = $.ajax({
			url: '/wunderground/ajax-lookup',
			success:  function(data){
				$('#wunderground-lookup-block-form #lookup-ajax-target').html(data);
				$('#wunderground-ajax-throbber').remove();

				// jQuery fails to work reliably for this in ie
				document.getElementById('edit-submit').disabled = false;
			},
			dataType: "html",
			data: {q : textfield.val()},
			type: "post",
			error: function(XMLHttpRequest, textStatus, errorThrown){
				$('#wunderground-ajax-throbber').remove();
				document.getElementById('edit-submit').disabled = false;
			}
		});
		return false;
	});

	/*** User Location Forecast Block ***/

	// if option set, implement slideshow for forecast block
	if (Drupal.settings.wunderground.usejs){
		ul = $('#wunderground-user-forecast-wrap');
		ul.addClass('wunderground-js-processed');
		li = $('#wunderground-user-forecast-wrap').children('li');
		firstLi = li.eq(0);

		// set to first element
		firstLi.addClass('wunderground-active');

		// ie workaround
		ieEqualizeHeight(ul, firstLi)

		// set heights equal
    if (!$.browser.msie){
      ul.css('height', firstLi.css('height'));
    }

		// prevent chrome race condition
		firstLi.find('img').load(function(){
			ul.css('height', firstLi.css('height'));
		});

		// back and forward click handler
		$('#wb, #wf').click(function(){
			activeLi = $('li.wunderground-active');
			activeLi.removeClass('wunderground-active');
			newIndex = activeLi.getIndex();

			// back or forward? reached limits?
			if ($(this).attr('id') == 'wb' && newIndex > 0){
				newIndex--;
			}else if ($(this).attr('id') == 'wf' && newIndex < (li.length-1)){
				newIndex++;
			}

			newLi = li.eq(newIndex)
			newLi.addClass('wunderground-active');
			ul.css('height', newLi.css('height'));
			ieEqualizeHeight(ul, newLi);
		});
	}
}

/*** Utilities ***/

// e1: element you want to set
// e2: element you want e1 to copy
function ieEqualizeHeight(e1, e2){
	if ($.browser.msie){
		e1.height(e2.eq(0).height());
	}
}

// handy function for getting an element's index when .index() fails in < 1.4
// courtesy of http://snipplr.com/view/15788/get-index-of-the-current-element/
$.fn.getIndex = function(){
	  var $p=$(this).parent().children();
    return $p.index(this);
}
